<?php
/**
 * Created by JetBrains PhpStorm.
 * User: geovanesantos
 * Date: 25/06/14
 * Time: 09:44
 * To change this template use File | Settings | File Templates.
 */

namespace Scheduler\Facade;
use Scheduler\Logic;

class SchedulerWizardManager {
    // Vai para a Stage de Paramêtros
    public static function nextProcesso(){
        $ok=true;
        $nome=tk_get_field_value("scd_Agen_Nome");
        if($nome == "" || $nome == null){
            tk_warning("O Campo Nome não pode ser nulo");
            $ok=false;
        }
        if($ok){
//            tk_set_env_var("Processo",new \Scheduler\Logic\ProcessQueue());
//            $processo=tk_get_env_var("Processo");
//            $processo->setName($nome);
            tk_set_context_vars("scd_Agen_Nome", "scd_Agen_ProcIni", $nome);
            $tipo=tk_get_field_value("scd_Agen_Tipo");
//            $processo->setType($tipo);
            tk_set_context_vars("scd_Agen_Tipo", "scd_Agen_ProcIni", $tipo);
            $desc=tk_get_field_value("scd_Agen_Desc");
//            $processo->setDesc($desc);
            tk_set_context_vars("scd_Agen_Desc", "scd_Agen_ProcIni", $desc);
//            tk_set_env_var("Processo", $processo);
            tk_open_wizard_stage("scd_Agen_ProcParams","scd_Agen");
        }
    }

    // Vai para a Stage de Modo
    public static function nextParamProc(){
        $ok=ProcessParamChecker::checkFields(true);
        if($ok){
//            $processo=tk_get_env_var("Processo");
            $activeFields=tk_get_env_var("ACTIVE_FIELDS_WIZARD");
            foreach($activeFields as $field){
//                $processo->addParameter($field, tk_get_field_value($field));
                tk_set_context_vars($field, "scd_Agen_ProcParams", tk_get_field_value($field));
            }
//            tk_set_env_var("Processo", $processo);
            tk_open_wizard_stage("scd_Agen_ProcMode", "scd_Agen");
        }
    }

    // Vai para a Stage Agendar ou para Tela de Confirmação
    public static function isAgendar(){
        $status=tk_get_field_value("scd_Agen_Status");

//        $processo=tk_get_env_var("Processo");
//        $processo->setStatus($status);
        tk_set_context_vars("scd_Agen_Status", "scd_Agen_ProcMode", $status);

        if($status=="AGENDADO"){
//            tk_set_env_var("Processo", $processo);
            tk_open_wizard_stage("scd_Agen_Agendar", "scd_Agen");
        }else{
            $priority=tk_get_field_value("scd_Agen_Priority");
//            $processo->setPriority($priority);
//            tk_set_env_var("Processo", $processo);
            tk_set_context_vars("scd_Agen_Priority", "scd_Agen_ProcMode", $priority);
            tk_open_wizard_stage("scd_Agen_Confirma", "scd_Agen");
        }

    }

    // Vai para uma das Stage Padrão de Agendamento
    public static function isTipoAgendar(){
        $type=tk_get_field_value("scd_Agen_Tipo");
        switch($type){
            case "MENSAL":
                tk_open_wizard_stage("scd_Agen_Mensal","scd_Agen");
                break;
            case "SEMANAL":
                tk_open_wizard_stage("scd_Agen_Semanal","scd_Agen");
                break;
            case "DIARIO":
                tk_open_wizard_stage("scd_Agen_Diario","scd_Agen");
                break;
            case "HORARIO":
                tk_open_wizard_stage("scd_Agen_Horario","scd_Agen");
                break;
            case "REG_INTERVAL":
                tk_open_wizard_stage("scd_Agen_Int_Reg","scd_Agen");
                break;
            default:
                tk_warning("Tipo de Agendamento não selecionado!");
                break;
        }
    }

//  Cron Customizada
    public static function runCustom(){
//        $processo=tk_get_env_var("Processo");
//        $processo->setSchedule($cron);
//        tk_set_env_var("Processo", $processo);
        $ok=\Scheduler\Facade\SchedulerWizardCronBuilder::buildCustomCron();
        if($ok){
            tk_open_wizard_stage("scd_Agen_Confirma","scd_Agen");
        }else{
            tk_message("Um campo necessário não foi preenchido!","warning");
        }
    }

    // Cron Mensal
    public static function runMonthly(){
        $dayMonth=tk_get_field_value("scd_Agen_Dia_Mes");
        $hour=tk_get_field_value("scd_Agen_HoraDia");
        $minute=tk_get_field_value("scd_Agen_MinutoDia");
        $cron=Array("$minute", "$hour", "$dayMonth", "*", "*");
        self::toConfirma($cron);
    }

    // Cron Semanal
    public static function runWeekly(){
        $dayWeek=tk_get_field_value("scd_Agen_Dia_Semana");
        $hour=tk_get_field_value("scd_Agen_HoraDia");
        $minute=tk_get_field_value("scd_Agen_MinutoDia");
        $cron=Array("$minute", "$hour", "*", "*", "$dayWeek");
        self::toConfirma($cron);
    }

    // Cron Diária
    public static function runDaily(){
        $hour=tk_get_field_value("scd_Agen_HoraDia");
        $minute=tk_get_field_value("scd_Agen_MinutoDia");
        $cron=Array("$minute", "$hour", "*", "*", "*");
        self::toConfirma($cron);
    }

    // Cron Horária
    public static function runHourly(){
        $minute=tk_get_field_value("scd_Agen_Minuto");
        $cron=Array("$minute", "*", "*", "*", "*");
        self::toConfirma($cron);
    }

    // Vai para a Stage de Confirmação
    public static function toConfirma($cron){
        tk_set_env_var("agen_ExpAgendada",$cron);
        tk_open_wizard_stage("scd_Agen_Confirma","scd_Agen");
    }

    // Confirma os Dados
    public static function confirma(){
        try{
            $processo=tk_get_env_var("Processo");
            $ok=$processo->saveQueue();
            if($ok!==false){
                tk_message("Foi salvo com sucesso!","success");
                tk_close_wizard("scd_Agen");
            }
        }
        catch(\Exception $e){
            $message="Ao tentar salvar o agendamento ocorreu um erro. <br /> O erro ocorrido foi:<br /> ".PHP_EOL.$e->getMessage();
            if($e->getMessage()=='HTTP error: 407'){
                $message .= PHP_EOL."<br/>Ação corretiva: Verifique a parametrização de autenticação de proxy";
            }
            tk_warning($message);
        }
    }

    // Limpa Tela ProcIni
    public static function clearStageProcIni(){
        $allFields=tk_get_all_fields();
        unset($allFields['_ID']);
        unset($allFields['_STATE']);
        unset($allFields['_CHECKED']);
        foreach($allFields as $name=>$field){
            if($name!="scd_Agen_Tipo"){
                tk_set_field_value($name,"");
            }else{
                tk_set_field_value($name, 3);
            }
        }
    }

    // Limpa Tela ProcParams
    public static function clearStageProcParams(){
        $allFields=tk_get_all_fields();
        unset($allFields['_ID']);
        unset($allFields['_STATE']);
        unset($allFields['_CHECKED']);
        foreach($allFields as $name=>$field){
            if($name!="CONTACTS"){
                tk_set_field_value($name,"");
            }else{
                tk_set_field_value($name,"N");
            }
        }
    }

    // Limpa Tela ProcMode
    public static function clearStageProcMode(){
        $allFields=tk_get_all_fields();
        unset($allFields['_ID']);
        unset($allFields['_STATE']);
        unset($allFields['_CHECKED']);
        foreach($allFields as $name=>$field){
            if($name=="scd_Agen_Status"){
                tk_set_field_value($name,"EXECUCAO");
            }elseif($name=="scd_Agen_Priority"){
                tk_set_field_value($name,5);
            }
        }
    }

    // Limpa Tela Agendar
    public static function clearStageAgendar(){
        $allFields=tk_get_all_fields();
        unset($allFields['_ID']);
        unset($allFields['_STATE']);
        unset($allFields['_CHECKED']);
        foreach($allFields as $name=>$field){
            tk_set_field_value($name,"MENSAL");
        }
    }

    // Limpa Tela Mensal
    public static function clearStageMensal(){
        $allFields=tk_get_all_fields();
        unset($allFields['_ID']);
        unset($allFields['_STATE']);
        unset($allFields['_CHECKED']);
        foreach($allFields as $name=>$field){
            if($name=="scd_Agen_Dia_Mes"){
                tk_set_field_value($name,1);
            }elseif($name=="scd_Agen_HoraDia"){
                tk_set_field_value($name,12);
            }elseif($name=="scd_Agen_MinutoDia"){
                tk_set_field_value($name,0);
            }
        }
    }

    // Limpa Tela Semanal
    public static function clearStageSemanal(){
        $allFields=tk_get_all_fields();
        unset($allFields['_ID']);
        unset($allFields['_STATE']);
        unset($allFields['_CHECKED']);
        foreach($allFields as $name=>$field){
            if($name=="scd_Agen_Dia_Semana"){
                tk_set_field_value($name,0);
            }elseif($name=="scd_Agen_HoraDia"){
                tk_set_field_value($name,12);
            }elseif($name=="scd_Agen_MinutoDia"){
                tk_set_field_value($name,0);
            }
        }
    }

    // Limpa Tela Diário
    public static function clearStageDiario(){
        $allFields=tk_get_all_fields();
        unset($allFields['_ID']);
        unset($allFields['_STATE']);
        unset($allFields['_CHECKED']);
        foreach($allFields as $name=>$field){
            if($name=="scd_Agen_HoraDia"){
                tk_set_field_value($name,12);
            }elseif($name=="scd_Agen_MinutoDia"){
                tk_set_field_value($name,0);
            }
        }
    }

    //Limpa Tela Horário
    public static function clearStageHorario(){
        $allFields=tk_get_all_fields();
        unset($allFields['_ID']);
        unset($allFields['_STATE']);
        unset($allFields['_CHECKED']);
        foreach($allFields as $name=>$field){
            if($name=="scd_Agen_Minuto"){
                tk_set_field_value($name,0);
            }
        }
    }


    public static function clearStageIntReg(){

        //Limpa Tela Intervalos Regulares
        $allFields=Array("minutos_list","horas_list","dias_mes_list","meses_list","dias_sem_list");
        foreach($allFields as $field){
                tk_set_field_value($field,3);
            }
    }
}